#include <os.h>
#include <n2dlib.c>
#include <cstdlib>
#include <ctime>
#include <cmath>
int score,board[4][4],nt;
enum option{menu,play}action=menu;
inline void drawString(int x,int y,const char *str,unsigned short fc)
{
	drawString(&x,&y,x,str,fc,0xffff);
}
inline void drawDecimal(int x,int y,int n,int c)
{
	drawDecimal(&x,&y,n,c,0xffff);
}
bool canMoveRight()
{
	for(int i=0;i<4;i++)
	{
		for(int z=3;z>0;z--)
		{
			if((board[i][z]==board[i][z-1]&&board[i][z]!=0)||(board[i][z]==0&&board[i][z-1]!=0))
			{
				return 1;
			}
		}
	}
	return 0;
}
void moveRight(int board[4][4])
{
	for(int k=0;k<6;k++)
	{
		for(int i=0;i<4;i++)
		{
			for(int z=3;z>0;z--)
			{
				if(board[i][z]==board[i][z-1]&&board[i][z]!=0)
				{
					board[i][z]*=2;
					score+=board[i][z];
					board[i][z-1]=0;
				}
				else if(board[i][z]==0&&board[i][z-1]!=0)
				{
					board[i][z]=board[i][z-1];
					board[i][z-1]=0;
				}
			}
		}
	}
}
bool canMoveLeft()
{
	for(int i=0;i<4;i++)
	{
		for(int z=0;z<3;z++)
		{
			if((board[i][z]==board[i][z+1]&&board[i][z]!=0)||(board[i][z]==0&&board[i][z+1]!=0))	
			{
				return 1;
			}
		}
	}
	return 0;
}
void moveLeft()
{
	for(int k=0;k<6;k++)
	{
		for(int i=0;i<4;i++)
		{
			for(int z=0;z<3;z++)
			{
				if(board[i][z]==board[i][z+1]&&board[i][z]!=0)
				{
					board[i][z]*=2;
					score+=board[i][z];
					board[i][z+1]=0;
				}
				else if(board[i][z]==0&&board[i][z+1]!=0)
				{
					board[i][z]=board[i][z+1];
					board[i][z+1]=0;
				}
			}
		}
	}
}
bool canMoveUp()
{
	for(int i=0;i<3;i++)
	{
		for(int z=0;z<4;z++)
		{
			if((board[i][z]==board[i+1][z]&&board[i][z]!=0)||(board[i][z]==0&&board[i+1][z]!=0))
			{
				return 1;
			}
		}
	}
	return 0;
}
void moveUp()
{
	for(int k=0;k<6;k++)
	{
		for(int i=0;i<3;i++)
		{
			for(int z=0;z<4;z++)
			{
				if(board[i+1][z]==board[i][z]&&board[i][z]!=0)
				{
					board[i][z]*=2;
					score+=board[i][z];
					board[i+1][z]=0;
				}
				else if(board[i][z]==0)
				{
					board[i][z]=board[i+1][z];
					board[i+1][z]=0;
				}
			}
		}
	}
}
bool canMoveDown()
{
	for(int i=3;i>0;i--)
	{
		for(int z=0;z<4;z++)
		{
			if((board[i][z]==board[i-1][z]&&board[i][z]!=0)||(board[i][z]==0&&board[i-1][z]!=0))
			{
				return 1;
			}
		}
	}
	return 0;
}
void moveDown()
{
	for(int k=0;k<6;k++)
	{
		for(int i=3;i>0;i--)
		{
			for(int z=0;z<4;z++)
			{
				if(board[i-1][z]==board[i][z]&&board[i][z]!=0)
				{
					board[i][z]*=2;
					score+=board[i][z];
					board[i-1][z]=0;
				}
				else if(board[i][z]==0)
				{
					board[i][z]=board[i-1][z];
					board[i-1][z]=0;
				}
			}
		}
	}
}
void newTile()
{
	int c=rand()%10,x=rand()%4,y=rand()%4;
	if(board[x][y]==0)
	{
		if(c!=0)board[x][y]=2;
		else board[x][y]=4;
		nt=4*x+y;
	}
	else newTile();
}
int main() 
{	
	srand(time(NULL));
	initBuffering();
	while(1)
	{
		switch(action)
		{
		case menu:
			clearBufferW();
			drawString(20,20,"2048\nPress any key to start\nPress Q or ESC to exit",0);
			updateScreen();
			wait_key_pressed();
			if(isKeyPressed(KEY_NSPIRE_ESC)||isKeyPressed(KEY_NSPIRE_Q))
			{
				deinitBuffering();
				return 0;
			}
			else
			{
				for(int i=0;i<4;i++)for(int z=0;z<4;z++)board[i][z]=0;
				score=0;
				action=play;
				goto splay;
			}
			break;
		case play:
			if(!canMoveUp()&&!canMoveDown()&&!canMoveLeft()&&!canMoveRight())
			{
				clearBufferW();
				drawString(40,100,"You lost with a score of",0);
				drawDecimal(40,140,score,0);
				drawString(40,180,"Press any key to continue",0);
				updateScreen();
				sleep(500);
				wait_key_pressed();
				action=menu;
				break;
			}
			splay:
			clearBufferW();
			newTile();
			drawLine(20,20,220,20,0);
			drawLine(20,220,220,220,0);
			drawLine(20,20,20,220,0);
			drawLine(220,20,220,220,0);
			drawString(240,100,"SCORE",0);
			drawDecimal(240,110,score,0);
			for(int i=0;i<4;i++)
			{
				for(int z=0;z<4;z++)
				{
					if(i*4+z!=nt)
					{
						drawLine(25+50*z,25+50*i,65+50*z,25+50*i,0);
						drawLine(25+50*z,65+50*i,65+50*z,65+50*i,0);
						drawLine(25+50*z,25+50*i,25+50*z,65+50*i,0);
						drawLine(65+50*z,25+50*i,65+50*z,65+50*i+1,0);
					}
					else
					{
						drawLine(25+50*z,25+50*i,65+50*z,25+50*i,0b0000001000011111);
						drawLine(25+50*z,65+50*i,65+50*z,65+50*i,0b0000001000011111);
						drawLine(25+50*z,25+50*i,25+50*z,65+50*i,0b0000001000011111);
						drawLine(65+50*z,25+50*i,65+50*z,65+50*i+1,0b0000001000011111);
					}
					if(board[i][z]!=0)
					{
						fillRect(26+50*z,26+50*i,38,38,0xffff-33*log2(board[i][z]));
						drawDecimal(45+50*z-numberWidth(board[i][z])/2,40+50*i,board[i][z],0);
					}
				}
			}
			updateScreen();
			wait_input:
			wait_key_pressed();
			if(isKeyPressed(KEY_NSPIRE_Q))
			{
				deinitBuffering();
				return 0;
			}
			else if(isKeyPressed(KEY_NSPIRE_ESC))
			{
				action=menu;
				break;
			}
			else if(isKeyPressed(KEY_NSPIRE_RIGHT)||isKeyPressed(KEY_NSPIRE_6))
			{
				if(!canMoveRight())goto wait_input;
				moveRight(board);
				while(isKeyPressed(KEY_NSPIRE_RIGHT)||isKeyPressed(KEY_NSPIRE_6))sleep(20);
			}
			else if(isKeyPressed(KEY_NSPIRE_LEFT)||isKeyPressed(KEY_NSPIRE_4))
			{
				if(!canMoveLeft())goto wait_input;
				moveLeft();
				while(isKeyPressed(KEY_NSPIRE_LEFT)||isKeyPressed(KEY_NSPIRE_4))sleep(20);
			}
			else if(isKeyPressed(KEY_NSPIRE_DOWN)||isKeyPressed(KEY_NSPIRE_5))
			{
				if(!canMoveDown())goto wait_input;
				moveDown();
				while(isKeyPressed(KEY_NSPIRE_DOWN)||isKeyPressed(KEY_NSPIRE_5))sleep(20);
			}
			else if(isKeyPressed(KEY_NSPIRE_UP)||isKeyPressed(KEY_NSPIRE_8))
			{
				if(!canMoveUp())goto wait_input;
				moveUp();
				while(isKeyPressed(KEY_NSPIRE_UP)||isKeyPressed(KEY_NSPIRE_8))sleep(20);
			}
		}
	}
}
